import React, { useEffect, useState } from "react";
import { StyledTextSkeleton } from "./TextSkeleton.styles";
const variousWidth = [
    7.58,
    5.27,
    13.54,
    6.63,
    0.28,
    14.8,
    0.33,
    11.26,
    14.1,
    10.59,
    3.38,
    13.5,
    7.71,
    3.34,
    7.96
];
/**
 * Хок для создания компонента плейсхолдера нескольких строк текста.
 * Размеры компонента задаются с помощью констант и соответствуют размерам [типографических элементов](/?path=/docs/).
 */ export const textSkeleton = (Component)=>({ lines, width, roundness, customGradientColor, lighter, animationType = 'shimmer', customFadeInColor, customFadeOutColor, size = 'bodyM', view = 'default', ...props })=>{
        const [fixedWidth, setFixedWidth] = useState(null);
        const [linesWidth, setLinesWidth] = useState([]);
        useEffect(()=>{
            if (!width) {
                setFixedWidth(null);
                const computedLengths = Array(lines).fill(0).reduce((acc, _, i)=>{
                    let w;
                    // Последняя строка
                    if (i === lines - 1 && lines !== 1) {
                        w = 45 - variousWidth[i % variousWidth.length];
                    } else if (lines === 1 || lines === 2) {
                        // Единственная или первая из двух
                        w = 100;
                    } else {
                        w = 100 - variousWidth[i % variousWidth.length];
                    }
                    return {
                        ...acc,
                        [i]: w
                    };
                }, {});
                setLinesWidth(Object.values(computedLengths));
                return;
            }
            if (!Number.isNaN(Number(width))) {
                setFixedWidth(`${width}%`);
            } else {
                setFixedWidth(String(width));
            }
        }, [
            width,
            lines
        ]);
        // TODO: Подумать как можно обойти явное приведение типов
        const ComponentSkeleton = Component;
        return /*#__PURE__*/ React.createElement(StyledTextSkeleton, props, Array.from(Array(lines), (_, i)=>{
            return /*#__PURE__*/ React.createElement(ComponentSkeleton, {
                key: `line:${i}`,
                size: size,
                view: view,
                roundness: roundness,
                animationType: animationType,
                lighter: lighter,
                customGradientColor: customGradientColor,
                customFadeInColor: customFadeInColor,
                customFadeOutColor: customFadeOutColor,
                style: {
                    width: fixedWidth || `${linesWidth[i]}%`
                }
            });
        }));
    };
